<#--
 # MCreator (https://mcreator.net/)
 # Copyright (C) 2012-2020, Pylo
 # Copyright (C) 2020-2023, Pylo, opensource contributors
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <https://www.gnu.org/licenses/>.
 #
 # Additional permission for code generator templates (*.ftl files)
 #
 # As a special exception, you may create a larger work that contains part or
 # all of the MCreator code generator templates (*.ftl files) and distribute
 # that work under terms of your choice, so long as that work isn't itself a
 # template for code generation. Alternatively, if you modify or redistribute
 # the template itself, you may (at your option) remove this special exception,
 # which will cause the template and the resulting code generator output files
 # to be licensed under the GNU General Public License without this special
 # exception.
-->

<#-- @formatter:off -->
<#include "../mcitems.ftl">
package ${package}.world.features.treedecorators;

public class ${name}LeaveDecorator extends LeaveVineDecorator {

    public static final Codec<${name}LeaveDecorator> CODEC = Codec.unit(${name}LeaveDecorator::new);
    public static final TreeDecoratorType<?> DECORATOR_TYPE = new TreeDecoratorType<>(CODEC);

    static {
        DECORATOR_TYPE.setRegistryName("${modid}:${registryname}_tree_leave_decorator");
        ForgeRegistries.TREE_DECORATOR_TYPES.register(DECORATOR_TYPE);
    }

    @Override
    protected TreeDecoratorType<?> type() {
        return DECORATOR_TYPE;
    }

    @Override
    public void place(LevelSimulatedReader level, BiConsumer<BlockPos, BlockState> biConsumer, Random random, List<BlockPos> listBlockPos, List<BlockPos> listBlockPos2) {
        listBlockPos2.forEach((blockpos) -> {
			if (random.nextFloat() <  0.25f) {
				BlockPos bp = blockpos.west();
				if (Feature.isAir(level, bp)) {
					addVine(level, Direction.WEST, bp, biConsumer);
				}
			}

			if (random.nextFloat() <  0.25f) {
				BlockPos bp = blockpos.east();
				if (Feature.isAir(level, bp)) {
					addVine(level, Direction.EAST, bp, biConsumer);
				}
			}

			if (random.nextFloat() <  0.25f) {
				BlockPos bp = blockpos.north();
				if (Feature.isAir(level, bp)) {
					addVine(level, Direction.NORTH, bp, biConsumer);
				}
			}

			if (random.nextFloat() <  0.25f) {
				BlockPos bp = blockpos.south();
				if (Feature.isAir(level, bp)) {
					addVine(level, Direction.SOUTH, bp, biConsumer);
				}
			}
        });
    }

    private static void addVine(LevelSimulatedReader levelReader, Direction direction, BlockPos pos, BiConsumer<BlockPos, BlockState> biConsumer) {
		biConsumer.accept(pos, ${mappedBlockToBlockStateCode(data.treeVines)});
        int i = 4;
        for(BlockPos blockpos = pos.below(); Feature.isAir(levelReader, blockpos) && i > 0; --i) {
			biConsumer.accept(blockpos, oriented(${mappedBlockToBlockStateCode(data.treeVines)}, direction));
            blockpos = blockpos.below();
        }
    }

	@SuppressWarnings("deprecation") private static BlockState oriented(BlockState blockstate, Direction direction) {
		return switch (direction) {
			case SOUTH -> blockstate.rotate(Rotation.CLOCKWISE_180);
			case EAST -> blockstate.rotate(Rotation.CLOCKWISE_90);
			case WEST -> blockstate.rotate(Rotation.COUNTERCLOCKWISE_90);
			default -> blockstate;
		};
	}
}
<#-- @formatter:on -->
